#!/usr/bin/env php
<?php /*

 Simple PHP-CLI web virus cleaner
 To be used on shell accounts with infected websites

 rev 0.5.4-dev


 INSTALLATION AND USAGE:

  1. Copy to some executable path (~/bin/ or /usr/local/bin/)
  2. chmod +x
  3. Run:
     clrvir.php - to scan within current working directory
     clrvir.php /some/directory/ - to scan within provided directory


 INFO:

  The virus' names are made up by myself, mostly by deobfuscating and analysing their code 
  and then catching on interesting function names there (like 'Mrobh' for example).

  BE WARNED: This code is highly experimental! I will not take any responsibility for any damage it may cause!

 by Maciej 'Kyeno' Taranienko <matt(no-spam)prayam.com>, 2011-2012
 GPLv3 OpenSource license, http://www.gnu.org/licenses/gpl-3.0.html


 TODO:
 - Sanitize the code!
 - Add reporting and logging


 TODO LATER:
 - Add nicer Mrobh virus detection, for example unpacking the b64 codes and analysing the content
 - Add more viruses detection
 - Consider some external virus patterns database
 - Consider auto-updating algorithm
 - Consider crontab-run option with email notification 
   on virus detection (verbose information on file date, size, etc)

*/

// PHP DRIVING & ENVIRONMENT SETUP
error_reporting(E_ALL ^ E_NOTICE);
ini_set('display_errors', 1);

// Funny class of static methods
class Clrvir {

	// patterns
	public static function getPatterns() {

		return array(

			// JS.FRK aka JS:Illredir-AX (Avast's name)
			array(
				'signature' => '/(var\sj;if\(j\!=\'l\'\).*?var\su_=new\sString\(\);)/si',
				'type' => 'regex',
				'size' => 0,
				'cure' => 'individual',
				'name' => 'JS.FRK',
				'info' => 'Freaky JavaScript: MSIE web virus discovered in early 2010'
			),

			// JS.Sweep
			array(
				'signature' => '<script src="http://sweepstakesandcontestsnow.com/nl.php?nnn=1"></script>\n',
				'type' => 'exact',
				'size' => 0,
				'cure' => 'clearPattern',
				'name' => 'JS.Sweep',
				'info' => 'Sweepstakes JavaScript: General web virus discovered in late 2011'
			),

			// PHP.Mrobh-B64
			array(
				'signature' => '/\<\?php \/\*\*\/ eval\(base64_decode\(\"aWYoZn.*?0gIH0\=\"\)\)\;\?\>/si',
				'type' => 'regex',
				'size' => 0,
				'cure' => 'clearPattern',
				'name' => 'PHP.Mrobh-B64',
				'info' => 'Mrobh PHP base64: Very nasty, self-propagating PHP virus encoded with Base64. Web-launch code'
			),

			// PHP.Mrobh-HC
			array(
				'signature' => '/\<\?php \$_8b7b\=\"\\\x63\\\x72.*?/si',
				'type' => 'regex',
				'size' => 28278,
				'cure' => 'deleteFile',
				'name' => 'PHP.Mrobh-HC',
				'info' => 'Mrobh PHP hellcode: Possibly backdoor for Mrobh PHP web-propagator'
			),

			// PHP.Ibinc-HC
			array(
				'signature' => '/preg_replace\(\"\/\.\*\/e\"\,\"\\\x65\\\x76\\\x61\\\x6C\\\x28\\\x67\\\x7A\\\x69\\\x6E\\\x66\\\x6C.*?\\\x3B\"\,\"\.\"\)\;\?\>/si',
				'type' => 'regex',
				'size' => 23343,
				'cure' => 'deleteFile',
				'name' => 'PHP.Ibinc-HC',
				'info' => 'ibinc.php hellcode: Most likely old RoundCube Webmail backdoor/hack'
			),

			// PHP.milw0rm/wso-HC+B64
			array(
				'signature' => '/preg_replace\(\"\/\.\*\/e\"\,\"\\\x65\\\x76\\\x61\\\x6C\\\x28\\\x67\\\x7A\\\x69\\\x6E\\\x66\\\x6C\\\x61\\\x74\\\x65\\\x28\\\x62\\\x61\\\x73\\\x65\\\x36\\\x34\\\x5F\\\x64\\\x65\\\x63\\\x6F\\\x64\\\x65\\\x28\'7b1tVxs50.*?j6Yn\/xc\=\'\\\x29\\\x29\\\x29\\\x3B\"\,\"\.\"\)\;/si',
				'type' => 'regex',
				'size' => 0,
				'cure' => 'clearPattern',
				'name' => 'PHP.milw0rm/wso-HC+B64',
				'info' => 'milw0rm/wso hellcode + base64: Nasty trojan that allows attacker to scan for suids, view /etc/shadow and do other dangerous things'
			),

			// PHP.Mrobh/gml_777-B64
			array(
				'signature' => '/\<\?php \/\*\*\/ eval\(base64_decode\(\"aWYoZnVuY3Rpb25fZXhpc3RzKCdvYl9zdGFydCcpJiYhaXNzZXQoJF9TRVJWRVJbJ21yX25vJ10pKX.*?\"\)\)\;\?\>/si',
				'type' => 'regex',
				'size' => 0,
				'cure' => 'clearPattern',
				'name' => 'PHP.Mrobh/gml_777-B64',
				'info' => 'Mrobh PHP base64: A part of Mrobh PHP propagator that creates TCP socket 777 to send some data; possibly notifying the virus owner about the hacked site. I came across versions owned by "http://www.lilypophilypop.com and http://sweepstakesandcontestsdo.com/" as well as ones with "http://ens122zzzddazz.com/ and http://www.cooperjsutf8.ru/" in them'
			),

			// HTA.enormous
			array(
				'signature' => '/\<IfModule mod_rewrite\.c\>.*?RewriteRule \.\* http\:\/\/enormousw1illa\.com.*?\<\/IfModule\>/si',
				'type' => 'regex',
				'size' => 0,
				'cure' => 'clearPattern',
				'name' => 'HTA.enormous',
				'info' => 'HTA.enormous: Nasty .htaccess vir causing browser redirects on most requests'
			),

			// HTA.enormous-garbage
			array(
				'signature' => '<IfModule mod_rewrite.c></IfModule>',
				'type' => 'exact',
				'size' => 0,
				'cure' => 'clearPattern',
				'name' => 'HTA.enormous-garbage',
				'info' => 'HTA.enormous-garbage: Garbage often left by fail HTA.enormous installs'
			),

			// JS.ScriptInjector-HC
			array(
				'signature' => '/document\.write\(\"\\\x3C\\\x73\\\x63\\\x72\\\x69\\\x70\\\x74\\\x20\\\x74\\\x79\\\x70\\\x65\\\x3D\\\x22\\\x74\\\x65\\\x78\\\x74\\\x2F\\\x6A\\\x61\\\x76\\\x61\\\x73\\\x63\\\x72\\\x69\\\x70\\\x74\\\x22.*?\\\x3C\\\x2F\\\x73\\\x63\\\x72\\\x69\\\x70\\\x74\\\x3E\"\)\;/si',
				'type' => 'regex',
				'size' => 0,
				'cure' => 'clearPattern',
				'name' => 'JS.ScriptInjector-HC',
				'info' => 'JS.ScriptInjector hellcode: Kill aggressive script injections done by document.write("<script type="text/javascript".*?</scrpt>'
			),

			// PHP.Moodalbox-HC+B64
			array(
				'signature' => '/\<\?php.*?preg_replace\(strrev\(.*?\"\\\x65\\\x76\\\x61\\\x6C\\\x28\\\x67\\\x7A\\\x69\\\x6E\\\x66\\\x6C\\\x61\\\x74\\\x65\\\x28\\\x62.*?\'\\\x29\\\x29\\\x29\\\x3B\"\,\"\.\"\)\;\?\>/si',
				'type' => 'regex',
				'size' => 8096,
				'cure' => 'clearPattern',
				'name' => 'PHP.Moodalbox-HC+B64',
				'info' => 'PHP.Moodalbox hellcode + base64: Highly obfuscated and compressed script, which opens a backdoor and propagates itself to over a hundred IP addresses around the world. Im not completely sure what exactly this one does as I never deobfuscated it completely, but its pretty obvious this is a nasty one'
			)
		);
	}

	// logging methods
	// TODO: formatting, logging
	public static function alert($file, $pattern) {

		print "\033[41m\033[1;37m" . $file . "\033[0;30m\033[41m INFECTED WITH " . $pattern['name'] . '!' . "\033[0m\n";
	}

	public static function warn($message) {

		print " ! $message\n";
	}

	public static function inform($message) {

		print " + $message\n";
	}

	// file operations
	public static function renameFile($file, $reason) {

		Clrvir::warn($reason . ' renaming to .vir.txt');
		return rename($file, $file . '.vir.txt');
	}
	public static function deleteFile($file, $reason = null) {

		Clrvir::inform($reason ? $reason : 'deleting file');
		return unlink($file);
	}
	public static function overwriteFile($file, $content) {

		// ** make sure this ltrim isnt harmfull in any case
		file_put_contents($file, ltrim($content));
	}
}


// Lib
function cleanDirectory($dir) {

	// failsafe
	if(!is_dir($dir) or !is_readable($dir)) Clrvir::warn("Cannot access $dir!");
	else {

		// set base dir
		$handler = dir($dir);

		while($file = $handler->read()) {

			// omit empty files
			if($file != '.' and $file != '..' and $file != SCRIPT_NAME) {

				$filepath = $dir . '/' . $file;

				// recurrency; directory matching
				if(is_dir($filepath)) cleanDirectory($filepath);

				// web file access	** CONSIDER adding Ruby files here as well
				else if(preg_match('/\.(htm|html|php|php3|php4|php5|js)$/s', $file) or preg_match('/\.hta.*?/si', $file)) {

					$content = file_get_contents($filepath);

					// iterate through patterns in search for infections
					foreach(Clrvir::getPatterns() as $pattern) {

						// re-fetch content in case of double-cleaning (or deleting) single file
						if(!$content) {

							if(!file_exists($filepath)) break;
							else $content = file_get_contents($filepath);
						}

						$infected = false;

						// search for infections
						if( ($pattern['type'] == 'regex' and preg_match($pattern['signature'], $content, $matches)) or ($pattern['type'] == 'exact' and stristr($content, $pattern['signature'])) ) $infected = true;

						// infected
						if($infected) {

							// alert
							Clrvir::alert($filepath, $pattern);

							// check if the file is writeable
							if(!is_writable($filepath)) Clrvir::warn('cannot cure! no write permissions!');

							// decide on proper cure method
							else {

								// deleteFile
								if($pattern['cure'] == 'deleteFile') {

									// remove or rename to .vir.txt if checksum size don't match
									if(filesize($filepath) == $pattern['size']) Clrvir::deleteFile($filepath);
									else Clrvir::renameFile($filepath, 'uncommon file size!');
								}

								// clearPattern
								else if($pattern['cure'] == 'clearPattern') {

									Clrvir::inform('performing standard repairs');

									// exact - remove by pattern
									if($pattern['type'] == 'exact') $fixed = str_replace($pattern['signature'], null, $content);
									else if($pattern['type'] == 'regex') $fixed = str_replace($matches[0], null, $content);

									// overwrite file
									Clrvir::overwriteFile($filepath, $fixed);
									unset($fixed, $content);

									// check for size and delete if 0byte
									clearstatcache();
									if(filesize($filepath) === 0) Clrvir::deleteFile($filepath, 'deleting file (0byte)');
								}

								// individual cures
								else if($pattern['cure'] == 'individual') {

									// JS.FRK cure (from clrvir 0.3-a, thePixers' edition)
									if($pattern['name'] == 'JS.FRK') {

										Clrvir::inform('performing individual, experimental repairs');

										// some addons for PHP/HTML
										if(preg_match('/\.(html|php)$/s', $file)) $fixed = str_replace('<script>'.$matches[0].'</script>', null, $content);
										else $fixed = str_replace($matches[0], null, $content);

										// fix gay signature silently
										//  ** L8R: make sure this sig remains always the same; it seems appearing in different places among infected files
										$fixed = trim(str_replace('<!--b2ca8df5a4b84226e686e78e76abf7ee-->', null, $fixed));

										// overwrite file
										Clrvir::overwriteFile($filepath, $fixed);
										unset($fixed);
									}

									// cure not implemented
									else Clrvir::renameFile($filepath, 'individual cure not implemented yet!');
								}

								// no cure :<
								else Clrvir::renameFile($filepath, 'there is either no known cure or the virus definition is bugged!');
							}
						}
					}
				}
			}
		}
	}
}

// Runtime

// Find scriptname (for further iteration exclusions)
$tmp = explode('/', __FILE__);
define(SCRIPT_NAME, $tmp[count($tmp) - 1]);
unset($tmp);

// Run recurrency
cleanDirectory(($argv[1] and is_dir($argv[1])) ? preg_replace('/\/$/', null, $argv[1]) : getcwd());

?>
